<a id="mypy-boto3-resourcegroupstaggingapi"></a>

# mypy-boto3-resourcegroupstaggingapi

[![PyPI - types-aiobotocore-resourcegroupstaggingapi](https://img.shields.io/pypi/v/types-aiobotocore-resourcegroupstaggingapi.svg?color=blue)](https://pypi.org/project/types-aiobotocore-resourcegroupstaggingapi)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-resourcegroupstaggingapi.svg?color=blue)](https://pypi.org/project/types-aiobotocore-resourcegroupstaggingapi)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-resourcegroupstaggingapi?color=blue)](https://pypistats.org/packages/types-aiobotocore-resourcegroupstaggingapi)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.ResourceGroupsTaggingAPI 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/resourcegroupstaggingapi.html#ResourceGroupsTaggingAPI)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-resourcegroupstaggingapi docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_resourcegroupstaggingapi/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-resourcegroupstaggingapi](#mypy-boto3-resourcegroupstaggingapi)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `ResourceGroupsTaggingAPI`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `ResourceGroupsTaggingAPI` service.

```bash
python -m pip install types-aiobotocore[resourcegroupstaggingapi]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[resourcegroupstaggingapi]` in your environment:
  `python -m pip install 'types-aiobotocore[resourcegroupstaggingapi]'`

Both type checking and auto-complete should work for `ResourceGroupsTaggingAPI`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[resourcegroupstaggingapi]` in your environment:
  `python -m pip install 'types-aiobotocore[resourcegroupstaggingapi]'`

Both type checking and auto-complete should work for `ResourceGroupsTaggingAPI`
service. No explicit type annotations required, write your `aiobotocore` code
as usual. Auto-complete can be slow on big projects or if you have a lot of
installed `types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[resourcegroupstaggingapi]` in your environment:
  `python -m pip install 'types-aiobotocore[resourcegroupstaggingapi]'`
- Run `mypy` as usual

Type checking should work for `ResourceGroupsTaggingAPI` service. No explicit
type annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[resourcegroupstaggingapi]` in your environment:
  `python -m pip install 'types-aiobotocore[resourcegroupstaggingapi]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ResourceGroupsTaggingAPI` service. No explicit
type annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ResourceGroupsTaggingAPIClient` provides annotations for
`session.create_client("resourcegroupstaggingapi")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_resourcegroupstaggingapi import ResourceGroupsTaggingAPIClient

session = get_session()
with async session.create_client("resourcegroupstaggingapi") as client:
    client: ResourceGroupsTaggingAPIClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_resourcegroupstaggingapi.paginator` module contains type
annotations for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_resourcegroupstaggingapi import ResourceGroupsTaggingAPIClient
from types_aiobotocore_resourcegroupstaggingapi.paginator import (
    GetComplianceSummaryPaginator,
    GetResourcesPaginator,
    GetTagKeysPaginator,
    GetTagValuesPaginator,
)

session = get_session()
with async session.create_client("resourcegroupstaggingapi") as client:
    client: ResourceGroupsTaggingAPIClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        get_compliance_summary_paginator: GetComplianceSummaryPaginator = client.get_paginator("get_compliance_summary")
        get_resources_paginator: GetResourcesPaginator = client.get_paginator("get_resources")
        get_tag_keys_paginator: GetTagKeysPaginator = client.get_paginator("get_tag_keys")
        get_tag_values_paginator: GetTagValuesPaginator = client.get_paginator("get_tag_values")
    ```







### Literals

`types_aiobotocore_resourcegroupstaggingapi.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_resourcegroupstaggingapi.literals import (
    ErrorCodeType,
    GetComplianceSummaryPaginatorName,
    GetResourcesPaginatorName,
    GetTagKeysPaginatorName,
    GetTagValuesPaginatorName,
    GroupByAttributeType,
    TargetIdTypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ErrorCodeType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_resourcegroupstaggingapi.type_defs` module contains
structures and shapes assembled to typed dictionaries for additional type
checking.

```python
from types_aiobotocore_resourcegroupstaggingapi.type_defs import (
    ComplianceDetailsTypeDef,
    DescribeReportCreationOutputTypeDef,
    FailureInfoTypeDef,
    GetComplianceSummaryInputRequestTypeDef,
    GetComplianceSummaryOutputTypeDef,
    GetResourcesInputRequestTypeDef,
    GetResourcesOutputTypeDef,
    GetTagKeysInputRequestTypeDef,
    GetTagKeysOutputTypeDef,
    GetTagValuesInputRequestTypeDef,
    GetTagValuesOutputTypeDef,
    PaginatorConfigTypeDef,
    ResourceTagMappingTypeDef,
    ResponseMetadataTypeDef,
    StartReportCreationInputRequestTypeDef,
    SummaryTypeDef,
    TagFilterTypeDef,
    TagResourcesInputRequestTypeDef,
    TagResourcesOutputTypeDef,
    TagTypeDef,
    UntagResourcesInputRequestTypeDef,
    UntagResourcesOutputTypeDef,
)

def get_structure() -> ComplianceDetailsTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-resourcegroupstaggingapi` version is the same as related
`boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-resourcegroupstaggingapi docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_resourcegroupstaggingapi/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
